:: ------------------------------ PRZEZNACZENIE SKRYPTU ------------------------------


:: Skrypt ma na celu zaagodzenie problemu "usypiajcego poczenia", jaki pojawi si w sieci Aero2 okoo czerwca 2015 r.
:: Problem ten objawia si nagym zamieraniem ruchu w poprawnie nawizanym poczeniu.
:: Wwczas, aby szybko odzyska sprawnie dziaajce poczenie, konieczne jest jego zrestartowanie.
:: W praktyce jednak ogromnie przeszkadza to w korzystaniu z Aero2, gdy problem ten nieustannie powraca.

:: Problem ten zosta zaobserwowany i opisany przez wielu uytkownikw na forum jdtech,
:: oraz zosta opisany przez Jakuba m.in. w dwch poniszych artykuach:
:: http://jdtech.pl/2015/09/aero2-uzytkownicy-bdi-sa-traktowani-gorzej.html
:: http://jdtech.pl/2015/07/problemy-z-szybkoscia-aero2-wakacje-2015.html

:: Obserwacje uytkownikw wskazuj na to, e problem ten jest szczeglnie dotkliwy dla uytkownikw modemw Huawei E173u-2.
:: Ponadto regularnie dotyka on take uytkownikw innych modeli modemw nie speniajcych wymogu kategorii 10.
:: Niestety problem ten moe wystpowa take na modemach wyszych kategorii (w ich wypadku by moe zaley to od lokalizacji).



:: Skrypt stara si podtrzymywa poczenie Aero2 przed usypianiem poprzez wysyanie zapyta ping,
:: ktre sumarycznie generuj bardzo niewielkie zuycie transferu danych, rzdu kilku MB na godzinn sesj poczenia.
:: Jeli jednak dojdzie do stanu upienia, wwczas stan ten zostanie wykryty, a poczenie automatycznie zrestartowane.

:: Do wykrywania trybu wpisywania captcha skrypt korzysta z dodatkowego programu dla wiersza polece "PortQry.exe",
:: ktry jest bezpatnie udostpniony pod adresem: https://www.microsoft.com/en-us/download/details.aspx?id=17148
:: (rozpoznanie trybu wpisywania captcha jest potrzebne po to, aby skrypt nie pomyli go ze stanem upienia).



:: Wskazwka: jeli po przetestowaniu skrypt speni oczekiwania, wwczas wygodnie bdzie doda go do katalogu "Autostart".
:: W tym celu warto utworzy skrt do skryptu, gdy we waciwociach skrtu dostpna bdzie opcja umoliwiajca
:: uruchomienie okienka skryptu w postaci zminimalizowanej i tak przygotowany skrt wystarczy doda do katalogu "Autostart".








:: ------------------------------ USTAWIENIA SKRYPTU ------------------------------

:: Poniej prosz wprowadzi odpowiednie ustawienia konfiguracyjne skryptu.
:: W szczeglnoci istotne jest pierwsze ustawienie, podajce nazw poczenia Aero2 skonfigurowanego w systemie.
:: Pozostae ustawienia mona pozostawi pocztkowo bez zmian, a nastpnie dostosowa je wedug potrzeby.



:: Do zmiennej "nazwa_polaczenia" prosz przypisa nazw pod jak poczenie Aero2 zostao skonfigurowane w systemie.

@set nazwa_polaczenia=Aero2



:: W razie wykrycia stanu upienia skrypt automatycznie wyczy i ponownie wczy (zrestartuje) poczenie.
:: Wczenie poczenia nastpi, jeli zmienna "wznawianie_restartowanego_polaczenia" ma przypisan warto "tak"
:: ( a wic ponisza linia jest wwczas zapisana nastpujco: @set wznawianie_restartowanego_polaczenia=tak ).
:: Jeli jednak do automatycznego wczania poczenia Aero2 wykorzystywany jest dodatkowy program,
:: np. program Aero3 z zaznaczon opcj "Zawsze cz Aero2", wwczas warto zmieni ponisz warto na dowoln inn ni "tak",
:: gdy w przeciwnym wypadku zarwno skrypt, jak i program kontrolujcy poczenie Aero2,
:: bd prbowa jednoczenie nawiza poczenie, co moe przeszkodzi w nawizaniu poczenia,
:: oraz moe spowodowa pokazywanie systemowego komunikatu o prbie ponownego wybierania tego samego numeru.

@set wznawianie_restartowanego_polaczenia=tak



:: Do zmiennej "rozmiar_pakietu" przypisany jest rozmiar pakietu testowanego przez polecenie ping, podany w bajtach.
:: Pocztkowo ustawiona jest warto 256, jeli jednak pomimo pracy skryptu wci zbyt czsto dochodzi do usypiania poczenia,
:: wwczas mona sprbowa zwikszy t warto, aby odszuka warto, przy ktrej usypianie nie wystpuje czsto.

@set rozmiar_pakietu=256



:: Zmienne "badane_IP" oraz "drugie_badane_IP" przechowuj dwa adresy IP testowane przez polecenie ping.
:: Mona przypisa im dowolne adresy dwch sprawnie dziaajcych hostw (odpowiadajcych na ping)
:: np. adresy serwerw duych portali internetowych, adresy serwerw DNS itp.
:: Wane jest tylko, aby byy to dwa rne adresy.

@set badane_IP=208.67.220.220
@set drugie_badane_IP=208.67.222.220



:: Przypisany do zmiennej "fragment_poszukiwanego_ciagu_znakow" fragment "czasu"
:: umoliwi dokadniejsze rozpoznanie negatywnej odpowiedzi zwrconej przez polecenie ping.
:: Poszukiwana tre odpowiedzi to "Upyn limit czasu dania" (ang. "Request timed out").
:: W przypadku korzystania z innej ni polska wersji jzykowej Windows prosz wprowadzi odpowiedni modyfikacj.

@set fragment_poszukiwanego_ciagu_znakow=czasu










:: ------------------------------ POCZTEK WACIWEJ CZʌCI SKRYPTU ------------------------------




:poczatek


:: komunikat dla uytkownika, wskazujcy na brak wykrytych problemw z poczeniem;
:: pojawi si on rwnie wtedy, gdy poczenie nie jest nawizane, gdy skrypt dla uproszczenia dziaania
:: nie prbuje wykrywa i odrnia braku nawizania poczenia od poczenia nawizanego
@echo.
@echo Trwa testowanie i podtrzymywanie polaczenia %nazwa_polaczenia% za pomoca ping





:: przez wikszo czasu pracy skrypt bdzie wykonywa ponisz ptl "podtrzymywanie_i_testowanie_polaczenia",
:: w ktrej wysyane jest zapytanie ping, nastawione na zwrcenie trzech odpowiedzi;
:: dopiero otrzymanie odpowiedzi negatywnych spowoduje przejcie skryptu do dalszej czci, sucej do wykrywania stanu upienia


:podtrzymywanie_i_testowanie_polaczenia

:: wykonane zostanie polecenie ping zwracajce trzy odpowiedzi
@ping -n 3 -l %rozmiar_pakietu% %badane_IP% > nul

:: jeli polecenie ping zakoczyo si pozytywnie, bdzie wykonywane ponownie,
:: a do momentu wystpienia odpowiedzi negatywnej, ktra wwczas zostanie zbadana dokadniej przez dalsz cz skryptu
@if %errorlevel% EQU 0 goto :podtrzymywanie_i_testowanie_polaczenia









:: dokadniejsze zbadanie odpowiedzi zwrconej przez ping w poszukiwaniu komunikatu "Upyn limit czasu dania"
@ping -n 1 %badane_IP% | find "%fragment_poszukiwanego_ciagu_znakow%" > nul

:: jeli zapytanie ping zwrcio odpowied pozytywn,
:: lub zwrcio odpowied "Host docelowy jest nieosigalny" wskazujc na brak nawizania poczenia,
:: wwczas skrypt powrci do ptli podtrzymujcej i testujcej poczenie (wzgldnie oczekujcej na nawizanie poczenia)
@if %errorlevel% NEQ 0 goto :podtrzymywanie_i_testowanie_polaczenia








:: poinformowanie uytkownika o wykryciu potencjalnych problemw z poczeniem;
:: nastpnie skrypt zbada, czy poczenie przeszo w tryb wpisywania captcha, w stan upienia,
:: czy te powrcio do penej sprawnoci, np. po szybkim przepisaniu captcha
@echo.
@echo Wykryto problem w dzialaniu polaczenia, nastapi jego zbadanie






:: zamiana badanych adresw IP; zostanie ona wykonana ju teraz, na wszelki wypadek,
:: pomimo e w tej czci skryptu jeszcze nie jest wiadomo, czy poczenie przeszo przez tryb wpisywania captcha;
:: skrypt moe jednak nie zdy uchwyci pojawienia si trybu captcha, a poniewa adres IP badany przez polecenie ping
:: w trybie captcha na pewien czas pozostanie "spalony", dlatego konieczne jest zastosowanie dwch wymienianych ze sob adresw
@set tymczasowe_IP=%badane_IP%
@set badane_IP=%drugie_badane_IP%
@set drugie_badane_IP=%tymczasowe_IP%







:: polecenie portqry umoliwi sprawdzenie, czy poczenie znajduje si w trybie wpisywania captcha;
:: dziki temu skrypt nie dokona bdnego rozpoznania stanu upienia poczenia,
:: kiedy w rzeczywistoci poczenie znajdzie si w trybie wpisywania captcha
@portqry -n bdi.free.aero2.net.pl -e 8080 -q > nul

:: polecenie portqry, badajce dostpno strony Aero2 do wpisywania captcha, zwrci warto 0
:: jeli poczenie znajduje si aktualnie w trybie wpisywania captcha;
@if %errorlevel% EQU 0 goto :wykrycie_trybu_captcha

:: moe si jednak zdarzy, e kod captcha zostanie szybko przepisany przez uytkownika,
:: a wwczas zanim skrypt wykona sprawdzenie obecnoci trybu captcha, tryb ten ju si zakoczy;
:: wtedy powysze polecenie portqry zwrci warto 2;
:: w takiej sytuacji skrypt nie zdy rozpozna trybu wpisywania captcha, ale pozna, e poczenie dziaa prawidowo,
:: dziki czemu powrci do dalszego podtrzymywania i testowania poczenia, bez bdnego wykrycia stanu upienia;
:: pewnym utrudnieniem jest to, e polecenie portqry zwrci warto 2 take w przypadku,
:: gdy poczenie znajdzie si w stanie upienia, dlatego skrypt wykona dodatkowy test ping,
:: w celu upewnienia si, czy doszo do stanu upienia, czy nie
@if %errorlevel% NEQ 2 goto :zrestartowanie_polaczenia_uspionego
@ping -n 1 %badane_IP% | find "%fragment_poszukiwanego_ciagu_znakow%" > nul
@if %errorlevel% EQU 0 (goto :zrestartowanie_polaczenia_uspionego) else (goto :poczatek)











:wykrycie_trybu_captcha

:: gdy skrypt wykryje tryb wpisywania captcha, wwczas bdzie czeka, a tryb ten zakoczy si
:: (nie wiadomo, jak dugo potrwa tryb captcha, a nie wolno ponagla uytkownika :-))
@echo.
@echo Wykryto tryb wpisywania captcha, nastapi zaczekanie na jego zakonczenie




:czekanie_na_opuszczenie_trybu_captcha

::  ponisze polecenie suy jako przenona wersja instrukcji zatrzymujcej skrypt na 2 sekundy
@ping 127.0.0.1 -n 2 > nul

:: polecenie portqry, badajce dostpno strony Aero2 do wpisywania captcha, zwrci warto 0
:: jeli poczenie znajduje si aktualnie w trybie wpisywania captcha;
@portqry -n bdi.free.aero2.net.pl -e 8080 -q > nul

@if %errorlevel% EQU 0 goto :czekanie_na_opuszczenie_trybu_captcha



:: tryb wpisywania captcha zakoczy si, a wic skrypt moe powrci do dalszego podtrzymywania i testowania poczenia
@goto :poczatek












:: jeli skrypt wykryje upienie poczenia, wwczas wykona ponisze polecenia, w celu zrestartowania poczenia

:zrestartowanie_polaczenia_uspionego

@echo.
@echo Wykryto uspienie polaczenia %nazwa_polaczenia%, nastapi jego zrestartowanie
@echo.

:: wyczenie poczenia
@rasdial %nazwa_polaczenia% /disconnect > nul

:: jeli zmienna "wznawianie_restartowanego_polaczenia" ma przypisan warto "tak",
:: wwczas skrypt wczy poczenie po rozczeniu;
:: najpierw jednak skrypt odczeka 2 sekundy,
:: gdy nawizywanie poczenia natychmiast po jego rozczeniu czsto koczy si niepowodzeniem
@if %wznawianie_restartowanego_polaczenia% == tak (
@ping 127.0.0.1 -n 2 > nul
@rasdial %nazwa_polaczenia%
)




:: upione poczenie zostao zrestartowane, a wic skrypt moe powrci do dalszego podtrzymywania i testowania poczenia
@goto :poczatek
	
	


